﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.3
@EndOfDesignText@
'Custom View class 
#Event: Click (Value As string)
#DesignerProperty: Key: Cycle, DisplayName: Cycle, FieldType: Boolean, DefaultValue: True, Description: Cyclic property.
#DesignerProperty: Key: Width, DisplayName: Width, FieldType: Int, DefaultValue: 50
#DesignerProperty: Key: Height, DisplayName: Height, FieldType: Int, DefaultValue: 150

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Panel
	Private Const DefaultColorConstant As Int = -984833 'ignore

	Private val As List
	Private Cycle As Boolean = True
	Private  hilbl As Label
	Private  medlbl As Label
	Private  lowlbl As Label
	Private cover As Panel
	
	Private selected As Int

	Private roll As Boolean = False
	Private mDelay As Int = 300
	Private q As Int
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	val.Initialize
End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)
	mBase = Base
	Cycle = Props.Get("Cycle")
	init_views
 End Sub

'Use when the wheel is created by code
public Sub CodeCreateView(Width As Int, Height As Int,list1 As List, cyclic As Boolean)
	Cycle = cyclic
	mBase.Initialize("")
	mBase.Width = Width
	mBase.height = Height
	init_views
	SetList(list1)
End Sub


private Sub init_views
	Dim w,h As Int
	w = mBase.Width
	h = mBase.Height/3
	
	hilbl.Initialize("lbl")
	hilbl.Color = Colors.White
	hilbl.TextColor = Colors.Black
	hilbl.TextSize = 20
	hilbl.Tag = 2
	hilbl.Gravity = Gravity.center
	mBase.AddView(hilbl,0,0,w,h)
	
	medlbl.Initialize("lbl")
	medlbl.Color = Colors.White
	medlbl.TextColor = Colors.Black
	medlbl.TextSize = 20
	medlbl.Tag = 1
	medlbl.Gravity = Gravity.center
	mBase.AddView(medlbl,0,h,w,h)
	
	lowlbl.Initialize("lbl")
	lowlbl.Color = Colors.White
	lowlbl.TextColor = Colors.Black
	lowlbl.TextSize = 20
	lowlbl.Tag = 0
	lowlbl.Gravity = Gravity.center
	mBase.AddView(lowlbl,0,2*h,w,h)
	
	cover.Initialize("cover")
'	cover.SetBackgroundImage(LoadBitmap(File.DirAssets,"cover.png"))  'mahares commented because of error file not in assets 8/12/18
	mBase.AddView(cover,0,-1%y,w,h*3 + 2%y)
End Sub

'Set the wheel's list of values
public Sub SetList(list1 As List)
	val = list1
	If Cycle = False Then
		val.InsertAt(val.Size,"")
		val.InsertAt(0,"")
	End If
	q = val.size
	
	lowlbl.Text = val.Get(0)
	medlbl.Text = val.Get(1)
	hilbl.Text = val.Get(2)
	selected = 1
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

private Sub lbl_Click
	Dim l As Label = Sender
	Dim k As Int = l.tag
	Select k
		Case 0
			If Cycle Or selected > 1 Then
				SetLabelsText( -1 )
			End If
		Case 1
			roll = False
		Case 2
			If Cycle Or selected < q -2 Then
				SetLabelsText( 1 )
			End If
	End Select
End Sub

private Sub lbl_LongClick
	Dim l As Label = Sender
	Dim k As Int = l.tag
	roll = True
	Do While roll
		Select k
			Case 0
				If Cycle Or selected > 1 Then
					SetLabelsText( -1 )
				Else
					roll = False
				End If
			Case 1
				roll = False
			Case 2
				If Cycle Or selected < q -2 Then
					SetLabelsText( 1 )
				Else
					roll = False
				End If
		End Select
		Sleep(mDelay)
	Loop
End Sub

private Sub SetLabelsText(k As Int)
	selected = (selected +k + q)  Mod q
	lowlbl.Text = val.get((selected - 1 + q) Mod q)
	medlbl.Text = val.get((selected)     Mod q)
	hilbl.Text = val.get((selected+1)   Mod q)
	Dim st As String = val.Get(selected)
	CallSub2(mCallBack,mEventName & "_Click",st)
End Sub

Public Sub SetByIndex(index As Int)
	If Cycle Then
		selected = (index+q) Mod q
	Else
		selected = (index+1+q) Mod q
	End If
	SetLabelsText( 0)
End Sub

Public Sub SetByValue(Value As String)
	selected = val.IndexOf(Value)
	If selected <> -1 Then SetLabelsText( 0)
End Sub

'Read the wheel's current value
public Sub ReadWheel As String
	Return medlbl.text
End Sub

'Set all appearance parameters:
'vcolor for view's background color
'tcolor for textcolor
'size for text size
public Sub SetAppearance(vcolor As Int,tcolor As Int,size As Int)
	SetColor(vcolor)
	SetTextColor(tcolor)
	SetTextSize(size)
End Sub

'Set color for view's background color
public Sub SetColor(color As Int)
	lowlbl.Color = color
	medlbl.Color = color
	hilbl.Color = color
End Sub

'Set color for the middle label only
public Sub SetMidColor(color As Int)
	medlbl.Color = color
End Sub

'Set color For view's text color
public Sub SetTextColor(color As Int)
	lowlbl.TextColor = color
	medlbl.TextColor = color
	hilbl.TextColor = color
End Sub

'Set color For mid label's text color
public Sub SetMidTextColor(color As Int)
	medlbl.TextColor = color
End Sub

'Set size for text size
public Sub SetTextSize(size As Int)
	lowlbl.Textsize = size
	medlbl.Textsize = size
	hilbl.Textsize = size
End Sub

'set delay for speed of wheel roll when longclick
public Sub SetDelay(Delay As Int)
	mDelay = Delay
End Sub




